--[[
--Last Man On the Hill v1.0
--By Darren Watts (W'rkncacnter)
--]]

spawns = {}
timer = {}
score = {}
waiting = {}
just_reset = true
reset_timer = 40
TIMER_INIT_AMT = 600
TIMER_AMOUNT = 450
last_player_to_die = -1
about_to_reset_timer = 0
able_to_win = {}

color_go = [[
2
#111111
&00ff00
]]

color_wait = [[
2
#111111
&ff0000
]]

icon_shape = [[
#####&&&&&&#####
####&&&&&&&&####
##&&&&&&&&&&&&##
#&&&&&&&&&&&&&&#
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&#
##&&&&&&&&&&&&##
##&&&&&&&&&&&&##
####&&&&&&&&####
#####&&&&&&#####
]]

function init()
	for i = 1, number_of_players(), 1 do
		spawns[i] = get_player_polygon(i-1)
		timer[i] = TIMER_INIT_AMT
		score[i] = 0
		waiting[i] = false
		able_to_win[i] = true
	end
end

function idle()
	set_score()
	update_reset_timer()
	update_timer()
	kill_player()
	player_stays_dead()
	use_overlay()
end

function set_score()
	for i = 0, number_of_players() - 1, 1 do
		set_points(i, score[i+1])
	end
end

function update_reset_timer()
	if(reset_timer > 0) then
		reset_timer = reset_timer - 1
	else
		just_reset = false
	end
	if(about_to_reset_timer > 0) then
		about_to_reset_timer = about_to_reset_timer - 1
	end
end

function update_timer()
	for i = 0, number_of_players() - 1, 1 do
		if(get_polygon_type((get_player_polygon(i))) == _polygon_is_hill and
			timer[i+1] <= TIMER_AMOUNT) then
			timer[i+1] = TIMER_AMOUNT
		elseif(waiting[i+1]) then
			timer[i+1] = TIMER_INIT_AMT
		elseif(timer[i+1] > 0) then
			timer[i+1] = timer[i+1] - 1
		end
	end
end

function kill_player()
	for i = 0, number_of_players() - 1, 1 do
		if(timer[i+1] == 0 and not only_one_not_waiting(i)) then
			inflict_damage(i, 1000)
		elseif(about_to_reset_timer == 0 and only_one_not_waiting(i) 
			and able_to_win[i+1] and not just_reset) then
			reset(i)
		elseif(about_to_reset_timer == 0 and only_one_not_waiting(i) 
			and able_to_win[last_player_to_die+1] and not just_reset) then
			reset(last_player_to_die)
		elseif(about_to_reset_timer == 0 and only_one_not_waiting(i) 
			and not able_to_win[i+1] and not able_to_win[last_player_to_die+1] and not just_reset) then
			reset(-1)
		end
	end
end

function player_stays_dead()
	for i = 0, number_of_players() - 1, 1 do
		if(player_is_dead(i) and timer[i+1] == 0) then
			waiting[i+1] = true
		end
	end
end

function player_killed(player, aggressor_player, action, projectile)
	local was_waiting = false
	if(waiting[player+1] == true) then
		was_waiting = true
	end
	waiting[player+1] = true
	about_to_be_reset_timer = 5
	if(player ~= aggressor_player and not only_one_not_waiting(player)) then 
		last_player_to_die = player
		if(not was_waiting and not only_one_not_waiting(aggressor_player)) then
			screen_print(get_player_name(player).." has been eliminated from the round!")
		end
	elseif(player ~= aggressor_player and only_one_not_waiting(player)
		and not just_reset) then
		last_player_to_die = player
		reset(player)
	elseif(player == aggressor_player and not only_one_not_waiting(player)) then
		able_to_win[player+1] = false
		screen_print(get_player_name(player).." has been eliminated from the round!")
	elseif(player == aggressor_player and only_one_not_waiting(player)
		and not just_reset) then 
		able_to_win[player+1] = false
		if(able_to_win[last_player_to_die+1]) then
			reset(last_player_to_die)
		else
			reset(-1)
		end
	end
end

function player_revived(player)
	if(waiting[player+1]) then
		inflict_damage(player, 1000)
		award_kills (-1, player, -1)
		screen_print(player, "You must wait until this round is over!")
	else
		able_to_win[player+1] = true
	end
end

function reset(player)
	just_reset = true
	reset_timer = 40
	if(player == -1) then
		screen_print("No one wins this round!")
	else
		screen_print(get_player_name (player).." wins the round!")
		score[player+1] = score[player+1] + 30
		local poly = math.mod (better_random (), table.getn(spawns))
		teleport_player (player, spawns[poly+1])
	end
	for i = 0, number_of_players() - 1, 1 do
		timer[i+1] = TIMER_INIT_AMT
		waiting[i+1] = false
		if(i ~= player) then
			able_to_win[i+1] = false
		end
		if(player ~= -1) then
			if(player_is_dead(player)) then
				able_to_win[player+1] = false
			end
		end
		if(get_life(i) < 150) then
			set_life(i, 150)
		end
	end
	for i = 1, table.getn(able_to_win), 1 do
		if(i-1 ~= player and player ~= -1) then
			able_to_win[i] = false
		end
	end
end

function use_overlay()
	local players_left = 0
	for i = 0, number_of_players() - 1, 1 do
		if(able_to_win[i+1] and not player_is_dead(i)) then players_left = players_left + 1 end
	end
	set_overlay_color(1, 0)
	set_overlay_text(1, "Plrs Left: "..players_left)
	local time_amount = math.floor(timer[local_player_index() + 1] / 30)
	if(time_amount > 10) then
		set_overlay_color(0, 0)
	elseif(time_amount > 5) then
		set_overlay_color(0, 5)
	else set_overlay_color(0, 2)
	end
	set_overlay_text(0, time_amount)
	local icon = nil
	if(player_is_dead(local_player_index()) and waiting[local_player_index() +1]) then
		icon = color_wait .. icon_shape
		set_overlay_icon(5, icon)
		set_overlay_color(5, 0)
		set_overlay_text(5, " ")
	elseif(player_is_dead(local_player_index()) and not waiting[local_player_index() +1]) then
		icon = color_go .. icon_shape
		set_overlay_icon(5, icon)
		set_overlay_color(5, 0)
		set_overlay_text(5, " ")
	elseif(not player_is_dead(local_player_index())) then
		set_overlay_text(5, "")
	end
end

function only_one_not_waiting(player)
	for i = 0, number_of_players() - 1, 1 do
		if(player == i) then do_nothing()
		elseif(waiting[i+1] == false) then return false
		end
	end
	return true
end

function do_nothing() end